/*
 * (C) Copyright IBM Corp. 2003    All Rights Reserved.
 * parsemd.c ($Revision: 1.4 $)
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corp.
 *
 * Author(s): S. Bader <shbader@de.ibm.com>
 *
 * This file is part of MDMPD.
 *
 * MDMPD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MDMPD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MDMPD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <stdio.h>
#include <stdlib.h>

#include <mdstat.h>

#define ERR(t, ...)	fprintf(stderr, t, ## __VA_ARGS__)
/* License statement */
static char *license = "\n(C) Copyright IBM Corp. 2003    All Rights Reserved.\nmdmpd.c ($Revision: 1.5 $)\nUS Government Users Resticted Rights -\nUse, Duplication or disclosure restricted by\nGSA ADP Schedule Contract with IBM Corp\n";

struct mds_info		mdi;

int main(void) {
	int	rc;
	int	i;
	int	j;

	(void) license;

	if(mdstat_register(MDSTAT_TYPE_WITHOUT_EVENTS) < 0)
		return -1;

	rc = mdstat_get(&mdi);

	printf("There were %ld events\n", mdi.events);

	for(i = 0; i < 256; i++) {
		if(mdi.md[i].status == array_inactive)
			continue;
		printf("md%d: level=%d disks=%d failed=%d\n",
			mdi.md[i].nr, mdi.md[i].level, mdi.md[i].disks,
			mdi.md[i].failed);

		for(j = 0; j < mdi.md[i].disks; j++) {
			printf(
				"disk%d(%03d:%03d) @%d = %d\n",
				j,
				mdi.md[i].disk[j].major,
				mdi.md[i].disk[j].minor,
				mdi.md[i].disk[j].seq_nr,
				mdi.md[i].disk[j].status
			);
		}
	}

	mdstat_unregister();

	return rc;
}
